; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; //---                 Damol Software                      ---\\ ;
; \\-----------------------------------------------------------// ;
; //---                  Dolmsgpw.asm                       ---\\ ;
; \\---                                                     ---// ;
; //---     Displays Quotations on the openning screen      ---\\ ;
; \\---                                                     ---// ;
; //-----------------------------------------------------------\\ ;
; \\--- Written by maDLess dam.zeugma@wanadoo.fr            ---// ;
; \\-----------------------------------------------------------// ;
; //--- the Damol Software Web Site :                       ---\\ ;
; \\---            http://fly.to/damol                      ---// ;
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;

 include "tios.h"
 include "util.h"

 xdef _main
 xdef _ti89
 xdef dolmsgpw@0000 ; export all the needed vars
 xdef dolmsgpw@0001 ; I didn't know we can export vars 
 xdef dolmsgpw@0002 ; from real progs ( not libs ) but 
 xdef dolmsgpw@0003 ; we can actually :-)
 xdef dolmsgpw@0004
 xdef dolmsgpw@0005
 xdef dolmsgpw@0006
 xdef dolmsgpw@0007
 xdef dolmsgpw@0008
 xdef dolmsgpw@0009

; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; // void Put_str ( char *String, int x, int y, int color );
; // Famous one
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;

Put_str MACRO
 move.w   \4,-(a7)
 pea      \1
 move.w   \3,-(a7)
 move.w   \2,-(a7)
 jsr      tios::DrawStrXY
 adda.l   #10,a7
 ENDM

; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; // void Get_str ( char *String, int x, int y, int num_char );
; // Quite spread one too
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;

Get_str MACRO
        move.w \2,d5
        move.w \3,d6
        move.w \4-1,d7
        move.w d7,d4
        move.l #\1,a5
        bsr take_string
        ENDM

_main:
shut
 jsr      util::zap_screen
 trap     #4
 Put_str  doline0,#0,#0,#4
 Put_str  doline1,#0,#10,#4
 Put_str  doline2,#0,#20,#4
 Put_str  doline3,#0,#30,#4
 Put_str  doline4,#0,#40,#4
 Put_str  doline5,#0,#50,#4
 Put_str  doline6,#0,#60,#4
 Put_str  doline7,#0,#70,#4
 Put_str  doline8,#0,#80,#4
 jsr      util::idle_loop 
 jsr      util::zap_screen
 Put_str  prompt,#10,#40,#4 
 Get_str  string,#72,#40,#10 
 pea      dolpwd                ; compare 'string' what u've entered with 'dolpwd' the real password
 pea      string
 jsr      tios::strcmp
 adda.l   #8,a7
 cmp.w    #0,d0                 ; if 'string'='sto_pass' -> exit
 beq      bye
 bra      shut                  ; else shut the calc down
bye
 rts

; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; // second part of the Get_str routine
; // ThanX to Alban Gervaise
; //  params : see the Get_str macro
; //  registers : d0,d4,d5,d6,d7 / a5,(a7) are lost
; // 
; // if try is set to 0 before u call the routine -> * instead of
; // real characters
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;

take_string:
 jsr      util::idle_loop
 cmp.w    #257,d0
 beq      undo
 cmp.w    #264,d0
 beq      bon
 cmp.w    #13,d0
 beq      bon
 move.b   d0,(a5)+
 move.w   #2,-(a7)
 move.w   d6,-(a7)
 move.w   d5,-(a7)

 cmp.b    #0,try                    ; if try is set to 0 
 beq      stars                     ; put stars
 move.w   d0,-(a7)                  ; else normal character
 bra      end_stars

stars
 move.w   #42,-(a7) 
end_stars
  
 jsr      util::DrawCharXY
 lea      8(a7),a7
 add.w    #6,d5
 dbra     d7,take_string
bon
 cmp.w    d4,d7
 beq      take_string
 clr.b    (a5)
 rts
undo
 cmp.w    d4,d7
 beq      take_string
 add.w    #1,d7
 clr.b    -(a5)
 sub.w    #6,d5
 move.w   #4,-(a7)
 move.w   d6,-(a7)
 move.w   d5,-(a7)
 move.w   #32,-(a7)
 jsr      util::DrawCharXY
 lea      8(a7),a7
 bra      take_string

; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;
; // The Data section                                          // ;
; //-----------------------------------------------------------\\ ;
; \\-----------------------------------------------------------// ;

prompt        dc.b "PassWord :",0
string        dc.b "          ",0             ; for the input
try           dc.b 0  

; 9 lines of 26 chars each = 1 huge quote, actually the biggest you
; can display...

dolmsgpw::line0
dolmsgpw@0000:
doline0       dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

dolmsgpw::line1
dolmsgpw@0001:
doline1       dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

dolmsgpw::line2
dolmsgpw@0002:
doline2       dc.b "      Don't take          ",0,0

dolmsgpw::line3
dolmsgpw@0003:
doline3       dc.b "      the Big             ",0,0

dolmsgpw::line4
dolmsgpw@0004:
doline4       dc.b "      Head !!             ",0,0

dolmsgpw::line5
dolmsgpw@0005:
doline5       dc.b "                          ",0,0
dolmsgpw::line6
dolmsgpw@0006:
doline6       dc.b "             ( Jeremy )   ",0,0

dolmsgpw::line7 
dolmsgpw@0007:
doline7       dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

dolmsgpw::line8
dolmsgpw@0008:
doline8       dc.b 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

dolmsgpw::sto_pass
dolmsgpw@0009:
dolpwd       dc.b "damol",0,0,0,0,0,0        ; 10 char max string for the password

; //**********************************************************\\ ;
; \\ end of the prog :-)                                      //
; //**********************************************************\\ ;
 end 